/* 
 *  
 *
 *  Copyright (C) Sander Striker                    2000.
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation,
 *  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef UUID_H
#define UUID_H

#include "includes.h"
#include "dcerpc_types.h"

#define uuid_s_ok 0

typedef struct
{
  unsigned32 time_low;
  unsigned16 time_mid;
  unsigned16 time_hi_and_version;
  unsigned8  clock_seq_hi_and_reserved;
  unsigned8  clock_seq_low;
  unsigned8  node[6];
} uuid_t;

signed32  uuid_compare(uuid_t *uuid1, uuid_t *uuid2, unsigned32 *status);
void      uuid_create(uuid_t *uuid, unsigned32 *status);
void      uuid_create_nil(uuid_t *uuid, unsigned32 *status);
boolean32 uuid_equal(uuid_t *uuid1, uuid_t *uuid2, unsigned32 *status);
void      uuid_from_string(unsigned_char_t *string_uuid, uuid_t *uuid, unsigned32 *status);
signed16  uuid_hash(uuid_t *uuid, unsigned32 *status);
boolean32 uuid_is_nil(uuid_t *uuid, unsigned32 *status);
void      uuid_to_string(uuid_t *uuid, unsigned_char_t **string_uuid, unsigned32 *status);

/* extensions to the original API */

void      uuid_copy(uuid_t *dest, const uuid_t *src, unsigned32 *status);

#endif /* UUID_H */
